//# sourceURL=Prueba.js
//método en el framework que se encarga de poder navegar entre tabs.
preBindTab(null);

//variable global para alojar lo seleccionado de la tabla Telefonos
var telefonoSeleccionado = "";
//Cargaremos en arrays lo que tenga las variables de session (de esta manera ya podremos tener las campanas y agentes sin hacer un select a la base),
var arrayCampanasTodas = getFromSessionStorage('campanasTodas');
var arrayAgentes = getFromSessionStorage('agentes');
//funcion para inicializar los calendarios, pasandole el id
var nombreAgente= Agent.accountcode;

//variable global que vamos a utilizar para asignar el rango al límite en los select a la base, en este caso traeremos cada 2 registros.
var limit = 2;
//en la siguiente variable global tendremos un select que traerá los primeros dos datos de la tabla, también la iremos modificando a medida que insertamos y eliminamos
var queryActual = "SELECT * FROM DC_Telefono WHERE agente='"+nombreAgente+"' ORDER BY proximo_contacto LIMIT "+limit+"";
//función para crear un calendario 
$('#proxmContactoCalendar').datetimepicker({
       format: 'DD/MM/YYYY HH:mm:ss',
       locale: 'es',
	   minDate: moment()
   	}
	);
//lo que se hace a continuación con esta linea de codigo es al hacerle click al id(boton en este ejemplo) llamara la función que se le pasa x parámetros.
//a la hora de ir al segundo tab siempre se ejecutara el método que se le pasa por parametros.
$('#tab22').click(generarEstadistica);
//funcion que contendrá los métodos iniciales del form.
init();
function init(){
	 traerTelefonos();
	 initComboCampTodas();
	 initComboAgentes();
}



//en la siguiente funcion se inicializará el combobox en caso que ya tengamos las campanas en la variable de session.
function initComboCampTodas(){
	 //en js preguntando solo por la variable si es true sabremos los siguientes casos(no es null, no es undefined, y sino viene vacía "", en estos casos la variable es false),
	 if(arrayCampanasTodas){
		//el metodo fullselect se encargará de completar los datos que tenemos en el array en un comobox
		//el primer parámetro a pasarle sera el solochosen: en este caso se lo pasaremos en 0 se encarga de inicializar el chosen con los objetos que le pasamos,
		//id del select html
		//una lista de valores o objetos que deseamos que tengan el combobox
		//el chosen
		//atributo, valor que deseamos mostrar en el combo(se usa cuando tienes un objeto).
	    //
		UC_fullSelect(0, 'cmbTodasCamp', arrayCampanasTodas, 1, null,1);
	 }else{
		  //en caso de no tener nada en la variable de session llamaremos al siguiente metodo donde obtendremos todas la campañas del sistema
	  	UC_getSystemCampaigns(setComboCampTodas);
	 }
}

//obtendremos las campanas del sistema
function setComboCampTodas(resp){
	// y al fullselect le pasaremos la respuesta	
	 UC_fullSelect(0, 'cmbTodasCamp', resp, 1, null,1);
	 //guardaremos la respuesta en la variable de session asignándole un nombre a la misma.
	 saveInSessionStorage('campanasTodas', resp);
}

function initComboAgentes(){
	 if(arrayAgentes){
		UC_fullSelect(0, 'libAgentes', arrayAgentes, 0, null,1);
	 }else{
		  //obtendremos todos los agentes
    	UC_getAgents(setListBoxAgentes);
	 }
}


function setListBoxAgentes(resp){
	 
	UC_fullSelect(0, 'libAgentes', resp, 0, null,1);
	saveInSessionStorage('agentes', resp);
}


//la siguiente fuincion traerá los datos para ingresar en la tabla
function traerTelefonos(){
	 /*con el metodo UC_get ejecutaremos un select de los datos que deseamos ingresar en la tabla,
	 se debera pasar por parametros una consulta, dns si es necesario, y se asignará un nombre para la funcion que retornara los datos*/
 	  UC_get(queryActual,"",respgettelefonos);
	 //tambien puede ejecutarce de esta manera un get
	 //var query = "SELECT * FROM DC_Telefono WHERE agente ='"+nombreAgente+"'";
	 //UC_get(query,"",respgettelefonos);
}

//En respgettelefonos usaremos los datos que nos devolvió el UC_get para armar la tabla(en este caso la ordenaremos descendente x la segunda fila).
//recibira un parametro json con los datos de la query ejecutada
function respgettelefonos(response){
	 //debemos parsear para dejar los datos en un array de objetos, con el fin de cambiar el formato por defecto que deja java
	var todosLosDeLaTabla =  JSON.parse(response);
	 // recorremos todos los datos para en caso de tener fecha en próximo contacto se le cambie el formato a mostrar en la tabla, 
	 // en este caso elegiremos el formato DD/MM/YYYY HH:mm:ss
   	 for(var i = 0; i < todosLosDeLaTabla.length; i++){ 
		  //al recorrer en cada proximo contacto validaremos si tiene, ya que si esta en null y formateamos un null se nos rompera.
		 if(todosLosDeLaTabla[i].proximo_contacto != "" && todosLosDeLaTabla[i].proximo_contacto != null && typeof todosLosDeLaTabla[i].proximo_contacto != 'undefined'){
		   //si pose proximo contacto formateamos la fecha que nos deja java MMM DD, YYYY hh:mm:ss A al formato DD/MM/YYYY HH:mm:ss
			var CALLDATE = moment(todosLosDeLaTabla[i].proximo_contacto, "MMM DD, YYYY hh:mm:ss A");
			  var fech = CALLDATE.formatWithJDF("DD/MM/YYYY HH:mm:ss");
                     todosLosDeLaTabla[i].proximo_contacto = fech;		 
		 }
	 
	 }
	 /*ahora con las fechas en el formato que queremos mostrar, se le pasara por parámetros el id de la tabla a inicializar, 
	 los datos en formato string(en caso de no tener que formatear nada se le pasara el json que recibimos en el metodo),
	 las columnas que se desean mostrar,
	 metodo que se va a ejecutar cuando ocurra el evento de seleccion en una fila de la tabla,
	 pixeles que desea tener la tabla,
	 formato de fecha a ordenar,
	 columna a ordenar,
	 manera de ordenar,
	 */
	 UC_fullTable("tablaTelefonos",JSON.stringify(todosLosDeLaTabla),"telefono,proximo_contacto",onSelectedTelefono,"100px","DD/MM/YYYY HH:mm:ss",1,"desc");
	 
  	 //el siguiente metodo agregara una paginacion para la tabla que se le pasa por parametros
    UC_addPagination('tablaTelefonos');

	//la paginacion crea un anterior y un siguiente,
	 //al hacer clic en anterior borraremos los datos de la tabla, rearmaremos la query para cambiarle el rango de limit, y obtendremos los datos con la nueva query
    $('#tablaTelefonos_anterior').click(function () {
        clearTable('tablaTelefonos');
		 //borramos de la query actual el limit
        queryActual = queryActual.indexOf('LIMIT') != -1 ? queryActual.substring(0, queryActual.indexOf('LIMIT')): queryActual;

        if(limit > 2)
            limit -= 2;
			//y asignaremos uno nuevo, ejemplo: el limite de la query que nos armara si se quiere ir a la pagina 2 seria (Select....LIMIT 2,2) desde esa posición traeme 2 registros
            queryActual +=  " LIMIT " + (limit - 2).toString() + " , " + 2;
			// llamaremos en el callback al metodo que nos arma la tabla,
            UC_get(queryActual, '', respgettelefonos);


		
    });

    $('#tablaTelefonos_siguiente').click(function () {
        clearTable('tablaTelefonos');
        queryActual = queryActual.indexOf('LIMIT') != -1 ? queryActual.substring(0, queryActual.indexOf('LIMIT')): queryActual;
		var limiteViejo=limit;
		limit = limit + 2;
        queryActual += " LIMIT " + limiteViejo + " , " + (2);

        UC_get(queryActual, '', respgettelefonos);
		

       
		 
    });
}

//nos limpiara una tabla,
function clearTable(idDeLaTabla) {
    var table = $('#' + idDeLaTabla).DataTable();

    table.clear();
    table.destroy();
}

//metodo que se va a ejecutar cuando ocurra el evento de seleccion en una fila de la tabla.
function onSelectedTelefono(objeto){
	 telefonoSeleccionado = objeto;
	 //llamaremos a esta funcion cada vez que seleccione la tabla(cargara los datos del objeto en inputs)
	 showTelefono();
}

// la siguiente funcion mostrara en inputs el objeto seleccionado de la tabla.
function showTelefono(){
	 //primero consultaremos si a seleccionado un telefono.
	 if(telefonoSeleccionado){
		  if(telefonoSeleccionado.proximo_contacto){
			   //de la siguiente manera agregamos el valor al elemento, en casos de ser select se le debera hacer un update del chosen.
			   $("#proxmContacto").val(telefonoSeleccionado.proximo_contacto);
			   $("#proxmContacto").trigger("chosen:updated");
		  }
		  $("#txttelefono").val(telefonoSeleccionado.telefono);
	 }
}

//lo que se hace a continuación con esta linea de codigo es al hacerle click al id(boton en este ejemplo) llamara la funcion que se le pasa x parametros.
$("#editar").click(editarTelefono);

//editaremos el telefono a la hora de tener seleccionado un telefono de la tabla y se actualice su fecha de proxm contacto
function editarTelefono(){
	 if(telefonoSeleccionado && telefonoSeleccionado.telefono == $("#txttelefono").val() && $("#proxmContacto").val()){
		  telefonoSeleccionado.telefono = $("#txttelefono").val();
		  telefonoSeleccionado.agente = nombreAgente;
		  telefonoSeleccionado.proximo_contacto = moment($("#proxmContacto").val(), 'DD/MM/YYYY HH:mm:ss').format("YYYY-MM-DD HH:mm:ss");
		  //para actualizar el registro en la base se deberá llamar al UC_update, pasándole el objeto con los campos a actualizar,
		  //tabla, columnas claves, dns si es necesario, funcion de retorno
          UC_update(telefonoSeleccionado, 'DC_Telefono', 'agente,telefono', '', checkResponseUpdate);
	 }else{
		  //el metodo de notificacion espera un titulo, mensaje, icono y tipo que dependiendo de cual le mandas cambiará su color.
		  notification("actualizar", "Seleccione un telefono, solo podrá editar proximo contacto", 'fa fa-times', 'danger');
	 }
}
//en la respuesta podremos checkear si se realizo exitosamente,(si la respuesta es "OK")
function checkResponseUpdate(resp){
	 if(resp == "OK"){
		notification("actualizar", "Se actualizo correctamente", 'fa fa-check', 'success');
		limpiar();
		//traeremos los datos nuevamente para actualizar la tabla.
    	traerTelefonos();
	 }else{
		  notification("actualizar", "no se logro actualizar", 'fa fa-times', 'danger');
	 }
	 
}

//lo que se hace a continuación con esta linea de codigo es al hacerle click al id "" llamara la funcion que se le pasa x parametros.
$("#eliminar").click(borrarTelefono);
//En este metodo se borrara el telefono seleccionado de la tabla.
function borrarTelefono(){
	 //primero se controlara si hay algo seleccionado en la tabla.
	 if(telefonoSeleccionado!= undefined && telefonoSeleccionado!= null && telefonoSeleccionado!=""){
		//en caso de tener algo seleccionado en la tabla, se guardara el telefono del objeto seleccionado
		  var telefonoSelec = telefonoSeleccionado.telefono;
		 //ejecutaremos un exec para eliminar de una tabla que posee dos claves primarias, 
		 //este metodo recibe los mismos paremetros que el get a diferencia que en el exec se podran ejecutar querys(INSERT, UPDATE, DELETE)
		 //UC_exec("DELETE FROM DC_Telefono WHERE telefono='"+telefonoSelec+"' AND agente='"+nombreAgente+"'","",traerTelefonos);
		 // con la ultima version del framework se podra eliminar de una tabla con dos claves primarias con el metodo UC_delete,
		 // se le debera pasar la tabla, las columnas que son claves primarias, el valor de cada clave primaria concatenadas,
		 // valor de los datos, dns si es necesario.
		 UC_delete('DC_Telefono', 'agente,telefono', nombreAgente+","+telefonoSelec, 'string,int', '', callbackEliminar);
		 //Aclaracion!! si vas a eliminar de una tabla con una clave primaria se le pasara solo la columna de la clave, ejemplo si la clave seria agente
		 //UC_delete('DC_Telefono', 'agente', nombreAgente, 'string', '', callbackEliminar);
		 // despues de eliminar de la tabla, se limpiaran los datos de los inputs.
		 limpiar();
	}else{
		notification("Eliminar", "debe seleccionar un telefono de la tabla", 'fa fa-times', 'danger');
	}

}


//en caso de ultilizar el metodo DC_delete, en la respuesta podremos checkear si se realizo exitosamente,(si la respuesta es "OK")
function callbackEliminar(resp){
	 if(resp=="OK"){
		  notification("eliminar", "elimino", 'fa fa-check', 'success');
		 
		  traerTelefonos();
	 }else{
		  notification("eliminar", "no elimino", 'fa fa-times', 'danger');
	 }
}


//lo que se hace a continuación con esta linea de codigo es al hacerle click al id(boton en este ejemplo) llamara la funcion que se le pasa x parametros.
$("#agregar").click(agregarNumero);

//Agregaremos un numero a la base, para despues volver a inicializar la tabla y verlo
function agregarNumero(){
	//Se validara que en el campo de numero cumpla cpn ser numero y se alla seleccionado una fecha en el calendar
    if (!isNaN($("#txttelefono").val()) && $("#proxmContacto").val()) { 
       //se creará un objeto para guardar
        var numeroSave= new Object();
        numeroSave.telefono = parseInt($("#txttelefono").val());
        numeroSave.agente = nombreAgente;
		var fechaAux = moment($("#proxmContacto").val(), 'DD/MM/YYYY HH:mm:ss');
        numeroSave.proximo_contacto = fechaAux.formatWithJDF("YYYY-MM-DD HH:mm:ss");//se debera formatear la fecha ya que la base acepta ese formato de fechas
        //ya teniendo el objeto completo con los datos que acepte la tabla a la cual insertamos, se le pasaran,
		//el objeto, nombre de la tabla en la cual se quiere guardar, dns si es necesario, y callback.
		 UC_Save(numeroSave,"DC_Telefono","",respAgregarNumero);
    }else{
		notification("Guardar", "debe ingresar los datos correctamente", 'fa fa-times', 'danger');
	}
}

function respAgregarNumero(resp){
	if(resp == "OK"){
    	notification("Guardar", "Se guardo correctamente", 'fa fa-check', 'success');
		limpiar();
		
    	traerTelefonos();
	}else{
   	 	notification("Guardar", "Error al guardar", 'fa fa-times', 'danger');
	}
}

//lo que se hace a continuación con esta linea de codigo es al hacerle click al id(boton en este ejemplo) llamara la funcion que se le pasa x parametros.
$("#limpiar").click(limpiar);

function limpiar(){
	 //limpiaremos los input utilizados y el telefono seleccionado
	 $("#txttelefono").val("");
	 $("#proxmContacto").val("");
	 telefonoSeleccionado="";
}

//con el metodo .bind definimos un evento change(en este caso este metodo subira un csv)
$("#csvfile").bind('change', function (e) {
	//aca obtendremos el nombre del archivo
	var ruta = $(this).val();
	//Dejamos el nombre a mostrar coqueto.
    var fileName = ruta.replace(/^.*\\/, "");
	//lo colocaremos en el input del de agregar un csv
    $("#textCodigosCSV").val(fileName);
    //nos quedamos con el archivo 
	var archivo = this.files[0];
	//preguntamos si ese archivo no viene vacio o null etc.
    if (archivo) {
        //llamaremos a validarCSV con el archivo
        validarCsv(archivo);
    } else {
        //el archivo no es valido
    }
});


function validarCsv(archivo) {
	//el Papa.parse nos ayudara a leer lo que posee el archivo csv 
    Papa.parse(archivo, {
        complete: function (results, file) {
            //con el result del Papa.parse podremos obtener los datos del csv para poder analizar si esta correcto
			var csv = results.data;
            //llamaremos dentro del if a analizar y si nos devuelve true es que el los datos del archivo son correctos
			 if (analizar(csv)) {
				  //con el archvio valido y sus datos correctos al metodo le pasamos el archivo, tabla, sentencia, y result
                UC_subirArchivoCSV(archivo, "DC_Telefono","IGNORE 1 LINES (agente,telefono,proximo_contacto)\n",respUploadCodigoCSV);
            } else {
              
                notification("subir", "error en el archvio a subir", 'fa fa-times', 'danger');
            }
        },
        delimiter: ";"//en el csv las columnas se separan con ;
    });
}

function analizar(data) {
    if (data[0].length > 3) {
        return false;
    }
    for (var i = 1; i < data.length; i++) {
        for (var j = 0; j < data[i].length; j++) {
            if (j == 0) {
                if (data[i][j] == ""||data[i][j].length>19||data[i][j].indexOf("'")!=-1 || data[i][j].indexOf('"')!=-1) {
                    return false;
                }
            }
            if (j == 1) {
                if (isNaN(data[i][j]) || data[i][j] == ""||data[i][j].indexOf("'")!=-1 || data[i][j].indexOf('"')!=-1) {
                    return false;
                }
            }
        }
    }
    return true;
}

//en la respuesta notificaremos actualizaremos la tabla.
function respUploadCodigoCSV(response){
    var field = document.getElementById('csvfile');
    field.value = field.defaultValue;
    notification("subir", "Se guardo correctamente", 'fa fa-check', 'success');
    setTimeout(function(){
        UC_get("SELECT * FROM DC_Telefono WHERE agente='"+nombreAgente+"'","",respgettelefonos);
    },2000);
}

//lo que se hace a continuación con esta linea de codigo es al hacerle click al id(boton en este ejemplo) llamara la funcion que se le pasa x parametros.
$("#btnCambiarDeTab").click(cambiarDeTab);

function cambiarDeTab(){
	 //la funcion de ir a un tab determinado solo necesita el id del tab
	 UC_goToTab('22-tab');
	 // llamaremos a generar estadistica siempre que vallas a ese tab
	 generarEstadistica();
}

//en generarEstadistica armaremos la query y ejecutaremos un get para tener los datos que queramos mostrar en la grafica
function generarEstadistica(){
	 //obtendremos la campana seleccionada
	 var campana = $('#cmbTodasCamp').val(); 
	 //validaremos si hay una campana seleccionada
	 if(campana!=null && campana!= undefined && campana!="" && campana !="Todas"){
		//en caso de tener se traera la suma de zonas x cada campana
	UC_get("select SUM(CASE WHEN zona ='Rural' THEN true ELSE false END) as Rural, SUM(CASE WHEN zona ='Urbano' THEN true ELSE false END) as Urbano, SUM(CASE WHEN zona ='No Especificado' THEN true ELSE false END) as NoEspecificado, SUM(CASE WHEN zona ='Costa' THEN true ELSE false END) as Costa FROM ccrepo.DC_BaseVentas WHERE campania = '"+campana+"'","",respGetGraph);
	 }else{
		  // en caso de no tener se traeran de todas las campanas..
		  UC_get("select SUM(CASE WHEN zona ='Rural' THEN true ELSE false END) as Rural, SUM(CASE WHEN zona ='Urbano' THEN true ELSE false END) as Urbano, SUM(CASE WHEN zona ='No Especificado' THEN true ELSE false END) as NoEspecificado, SUM(CASE WHEN zona ='Costa' THEN true ELSE false END) as Costa FROM ccrepo.DC_BaseVentas","",respGetGraph);
	 }
}

//en la respuesta del get debemos armar un array de objetos 
function respGetGraph(resp){
	//parseamos la respuesta
   var object = JSON.parse(resp);
	 //y obteniendo cada resultado de la query se debera parsear a un int(ya que las graficas necesitan numeros para generar los porcentajes)
   var rural = parseInt(object[0].Rural);
   var urbano = parseInt(object[0].Urbano);
   var noespecificado = parseInt(object[0].NoEspecificado);
   var costa = parseInt(object[0].Costa);
	// obteniendo cada resultado ahora si podremos armar el array de datos para pasarle al metodo que genera la grafica. cada dato tendrá su clave 
   var array = [['Rural', rural],['Urbano', urbano],['No Especificado', noespecificado],['Costa', costa]];	
	 //el metodo de graficas espera el id donde ira alojada la grafica, el array armado de datos, tipo de grafica, titulo, colores, tamano(null tomara el tamaño del contenedor)
   UC_generateGraphic('grafica',array,'donut','Zonas',null,null);
}

//lo siguiente sera hacer uso del metodo makecall que sirve para realizar llamadas.

//se llamara mediante el html con la propiedad onlick en el boton
function llamar(){
	//obtenemos el telefono del input
    var numero = $("#txtTelAllamar").val();
	// y la campana a llamar
	var camp = $("#cmbTodasCamp").val();
	//se validara que sea un numero y que no se elija campanas Todas
    if(!isNaN(numero) && camp!="Todas"){
		 //con esta propiedad deshabilitamos el boton ya que nos pueden volver a clickear la llamada
		  $("#btnLlamar").attr('disabled',true);
		//El metodo makeCall necesita la campana a llamar y destinatario.
    	UC_makeCall(camp,numero,numero,respmakecall);
  	}else{
	    notification("Llamar", "Debe seleccionar una campana y un numero", 'fa fa-times', 'danger');
  	}
}//
function respmakecall(response){
    GUID= response;
    if(GUID!=""){
       
    }
}

//se llamara mediante el html con la propiedad onlick en el boton
//en este caso cortaremos la llamada y cerraremos el form
function enForm(){
	 //tan simple como llamar a closeForm cierra el form
	 UC_closeForm();
}

//se llamara mediante el html con la propiedad onlick en el boton
function cortarLlamada(){
	 //cortaremos la llamada y volveremos habilitar el boton
	 UC_hangUp();
	 $("#btnLlamar").attr('disabled',false);
}



//A la hora de clicear sobre el chkBox de pausar llamaremos una funcion que nos pause el agente,
$('#chkPausar').click(function () {
	//validaremos que se alla checkeado 
	if($('#chkPausar').is(':checked')){
		 //borraremos el check de despausar
	$('#chkDesPausar').prop('checked', false);
		 //y llamamos al metodo pause para pausar el agente,(si se desea despausar se pasara el boolean en false)
    UC_pause(true,callBackPausar);
	}
});

//respuesta del UC pause
function callBackPausar(resp){
	 //en la respuesta Si se realizo exitosamente Obtendremos un "Success"
 if(resp=="Success"){
   notification("Pausar", "Se pauso el agente", 'fa fa-check', 'success');
 }
}

//A la hora de clicear sobre el chkBox despausar llamaremos una funcion que nos despause el agente,
$('#chkDesPausar').click(function () {
	 if($('#chkPausar').is(':checked')){
	 $('#chkPausar').prop('checked', false);
	 UC_pause(true,callBackDesPausar);
	 }
});

function callBackDesPausar(resp){
	 if(resp=="Success"){
   notification("Pausar", "Se despauso el agente", 'fa fa-check', 'success');
	 } 
}


